Index: issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/DoubleMatExternalResult.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/DoubleMatExternalResult.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/DoubleMatExternalResult.cpp	(revision 12878)
@@ -0,0 +1,166 @@
+/*!\file DoubleMatExternalResult.c
+ * \brief: implementation of the DoubleMatExternalResult object
+ */
+
+/*header files: */
+/*{{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include <stdio.h>
+#include <string.h>
+#include "../objects.h"
+#include "../../../EnumDefinitions/EnumDefinitions.h"
+#include "../../../shared/shared.h"
+#include "../../../Container/Container.h"
+#include "../../../include/include.h"
+/*}}}*/
+
+/*DoubleMatExternalResult constructors and destructor*/
+/*FUNCTION DoubleMatExternalResult::DoubleMatExternalResult(){{{*/
+DoubleMatExternalResult::DoubleMatExternalResult(){
+	return;
+}
+/*}}}*/
+/*FUNCTION DoubleMatExternalResult::DoubleMatExternalResult(int in_id, int enum_type,IssmDoubleMat values,int M,int N,int in_step,IssmDouble in_time){{{*/
+DoubleMatExternalResult::DoubleMatExternalResult(int in_id, int in_enum_type,IssmDouble* in_values, int in_M,int in_N,int in_step,IssmDouble in_time){
+
+	id=in_id;
+	enum_type=in_enum_type;
+	M=in_M;
+	N=in_N;
+
+	/*Copy result in values*/
+	if(M*N){
+		values=xNew<IssmDouble>(M*N);
+		xMemCpy<IssmDouble>(values,in_values,M*N);
+	}
+	else values=NULL;
+
+	step=in_step;
+	time=in_time;
+}
+/*}}}*/
+/*FUNCTION DoubleMatExternalResult::~DoubleMatExternalResult(){{{*/
+DoubleMatExternalResult::~DoubleMatExternalResult(){
+
+	xDelete<IssmDouble>(this->values);
+	return;
+}
+/*}}}*/
+
+/*Object virtual functions definitions:*/
+/*FUNCTION DoubleMatExternalResult::Echo {{{*/
+void DoubleMatExternalResult::Echo(void){
+
+	_printLine_("DoubleMatExternalResult:");
+	_printLine_("   enum: " << this->enum_type << " (" << EnumToStringx(this->enum_type) << ")");
+	_printLine_("   step: " << this->step);
+	_printLine_("   time: " << this->time);
+	_printLine_("   matrix size: " << this->M << "-" << this->N);
+
+}
+/*}}}*/
+/*FUNCTION DoubleMatExternalResult::DeepEcho{{{*/
+void DoubleMatExternalResult::DeepEcho(void){
+
+	int i,j;
+	
+	_printLine_("DoubleMatExternalResult:");
+	_printLine_("   id: " << this->id);
+	_printLine_("   enum: " << this->enum_type << " (" << EnumToStringx(this->enum_type) << ")");
+	_printLine_("   step: " << this->step);
+	_printLine_("   time: " << this->time);
+	_printLine_("   matrix size: " << this->M << "-" << this->N);
+	for (i=0;i<this->M;i++){  
+		_printString_("   [ ");
+		for (j=0;j<this->N;j++){
+			_printString_( " " << setw(11) << setprecision (5) << this->values[i*this->N+j]);
+		}  
+		_printLine_(" ]");
+	}  
+
+}
+/*}}}*/
+/*FUNCTION DoubleMatExternalResult::Id{{{*/
+int    DoubleMatExternalResult::Id(void){ return -1; }
+/*}}}*/
+/*FUNCTION DoubleMatExternalResult::MyRank{{{*/
+int    DoubleMatExternalResult::MyRank(void){ 
+	extern int my_rank;
+	return my_rank; 
+}
+/*}}}*/
+/*FUNCTION DoubleMatExternalResult::ObjectEnum{{{*/
+int DoubleMatExternalResult::ObjectEnum(void){
+
+	return DoubleMatExternalResultEnum;
+
+}
+/*}}}*/
+/*FUNCTION DoubleMatExternalResult::copy{{{*/
+Object* DoubleMatExternalResult::copy() {
+	
+	return new DoubleMatExternalResult(this->id,this->enum_type,this->values,this->M,this->N,this->step,this->time);
+
+}
+/*}}}*/
+
+/*DoubleMatExternalResult management: */
+/*FUNCTION DoubleMatExternalResult::WriteData{{{*/
+void   DoubleMatExternalResult::WriteData(FILE* fid,bool io_gather){
+
+	int     length;
+	int     type;
+	int     rows,cols;
+	char   *name    = NULL;
+	extern  int my_rank;
+	IssmPDouble *passiveDouble_p=NULL;
+	IssmPDouble passiveDouble;
+
+	if(io_gather){
+		/*we are gathering the data on cpu 0, don't write on other cpus: */
+		if(my_rank) return;
+	}
+
+	passiveDouble_p=xNew<IssmPDouble>(M*N);
+
+	/*First write enum: */
+	EnumToStringx(&name,this->enum_type);
+	length=(strlen(name)+1)*sizeof(char);
+	fwrite(&length,sizeof(int),1,fid);
+	fwrite(name,length,1,fid);
+	xDelete<char>(name);
+
+	/*Now write time and step: */
+	passiveDouble=reCast<IssmPDouble>(time);
+	fwrite(&passiveDouble,sizeof(IssmPDouble),1,fid);
+	fwrite(&step,sizeof(int),1,fid);
+
+	/*writing a IssmDouble array, type is 3:*/
+	type=3;
+	fwrite(&type,sizeof(int),1,fid);
+	rows=this->M;
+	fwrite(&rows,sizeof(int),1,fid);
+	cols=this->N;
+	fwrite(&cols,sizeof(int),1,fid);
+	for (int i=0; i<N*M; ++i) passiveDouble_p[i]=reCast<IssmPDouble>(values[i]);
+	fwrite(passiveDouble_p,cols*rows*sizeof(IssmPDouble),1,fid);
+	xDelete(passiveDouble_p);
+
+}
+/*}}}*/
+/*FUNCTION DoubleMatExternalResult::GetResultName{{{*/
+void DoubleMatExternalResult::GetResultName(char** pname){
+	EnumToStringx(pname,this->enum_type);
+}
+/*}}}*/
+/*FUNCTION DoubleMatExternalResult::GetStep{{{*/
+int DoubleMatExternalResult::GetStep(void){
+
+	return this->step;
+}
+/*}}}*/
Index: issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/DoubleMatExternalResult.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/DoubleMatExternalResult.h	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/DoubleMatExternalResult.h	(revision 12878)
@@ -0,0 +1,56 @@
+/*! \file DoubleMatExternalResult.h 
+ */
+
+
+#ifndef _DOUBLEMATEXTERNALRESULT_H_
+#define _DOUBLEMATEXTERNALRESULT_H_
+
+/*Headers:*/
+/*{{{*/
+
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include "./ExternalResult.h"
+#include "../../../include/include.h"
+#include "../../../shared/shared.h"
+#include "../../../include/include.h"
+#include "../../../include/include.h"
+/*}}}*/
+
+class DoubleMatExternalResult: public ExternalResult{
+
+	private: 
+		int id;
+		int enum_type;
+		IssmDouble* values;
+		int M;
+		int N;
+		int step;
+		IssmDouble time;
+
+	public:
+		/*DoubleMatExternalResult constructors, destructors: {{{*/
+		DoubleMatExternalResult();
+		DoubleMatExternalResult(int id,int enum_type,IssmDouble* values,int M,int N,int step, IssmDouble time);
+		~DoubleMatExternalResult();
+		/*}}}*/
+		/*Object virtual functions definitions:{{{ */
+		void  Echo();
+		void  DeepEcho();
+		int   Id(); 
+		int   MyRank();
+		int   ObjectEnum();
+		Object* copy();
+		/*}}}*/
+		/*ExternalResult managemnet: {{{*/
+		int   InstanceEnum(){return enum_type;}
+		void  WriteData(FILE* fid,bool io_gather);
+		void  GetResultName(char**);
+		int   GetStep(void);
+		/*}}}*/
+};
+#endif  /* _DOUBLEMATEXTERNALRESULT_H */
Index: issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/DoubleVecExternalResult.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/DoubleVecExternalResult.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/DoubleVecExternalResult.cpp	(revision 12878)
@@ -0,0 +1,152 @@
+/*!\file DoubleVecExternalResult.c
+ * \brief: implementation of the DoubleVecExternalResult object
+ */
+
+/*header files: */
+/*{{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include <stdio.h>
+#include <string.h>
+#include "../objects.h"
+#include "../../../EnumDefinitions/EnumDefinitions.h"
+#include "../../../shared/shared.h"
+#include "../../../Container/Container.h"
+#include "../../../include/include.h"
+/*}}}*/
+
+/*DoubleVecExternalResult constructors and destructor*/
+/*FUNCTION DoubleVecExternalResult::DoubleVecExternalResult(){{{*/
+DoubleVecExternalResult::DoubleVecExternalResult(){
+	return;
+}
+/*}}}*/
+/*FUNCTION DoubleVecExternalResult::DoubleVecExternalResult(int enum_type,IssmDoubleVec values,int M,int in_step,IssmDouble in_time){{{*/
+DoubleVecExternalResult::DoubleVecExternalResult(int in_id, int in_enum_type,IssmDouble* in_values, int in_M,int in_step,IssmDouble in_time){
+
+	id=in_id;
+	enum_type=in_enum_type;
+	M=in_M;
+
+	if(M){
+		values=xNew<IssmDouble>(M);
+		xMemCpy<IssmDouble>(values,in_values,M);
+	}
+	else values=NULL;
+
+	step=in_step;
+	time=in_time;
+}
+/*}}}*/
+/*FUNCTION DoubleVecExternalResult::~DoubleVecExternalResult(){{{*/
+DoubleVecExternalResult::~DoubleVecExternalResult(){
+	xDelete<IssmDouble>(values);
+	return;
+}
+/*}}}*/
+
+/*Object virtual functions definitions:*/
+/*FUNCTION DoubleVecExternalResult::Echo {{{*/
+void DoubleVecExternalResult::Echo(void){
+
+	_printLine_("DoubleVecExternalResult:");
+	_printLine_("   enum: " << this->enum_type << " (" << EnumToStringx(this->enum_type) << ")");
+	_printLine_("   vector size: " << this->M);
+	_printLine_("   step: " << this->step);
+	_printLine_("   time: " << this->time);
+
+}
+/*}}}*/
+/*FUNCTION DoubleVecExternalResult::DeepEcho{{{*/
+void DoubleVecExternalResult::DeepEcho(void){
+
+	int i;
+	
+	_printLine_("DoubleVecExternalResult:");
+	_printLine_("   id: " << this->id);
+	_printLine_("   enum: " << this->enum_type << " (" << EnumToStringx(this->enum_type) << ")");
+	_printLine_("   vector size: " << this->M);
+	for(i=0;i<this->M;i++){
+		_printLine_(i << " " << this->values[i]);
+	}
+	_printLine_("   step: " << this->step);
+	_printLine_("   time: " << this->time);
+}
+/*}}}*/
+/*FUNCTION DoubleVecExternalResult::Id{{{*/
+int    DoubleVecExternalResult::Id(void){ return -1; }
+/*}}}*/
+/*FUNCTION DoubleVecExternalResult::MyRank{{{*/
+int    DoubleVecExternalResult::MyRank(void){ 
+	extern int my_rank;
+	return my_rank; 
+}
+/*}}}*/
+/*FUNCTION DoubleVecExternalResult::ObjectEnum{{{*/
+int DoubleVecExternalResult::ObjectEnum(void){
+
+	return DoubleVecExternalResultEnum;
+
+}
+/*}}}*/
+/*FUNCTION DoubleVecExternalResult::copy{{{*/
+Object* DoubleVecExternalResult::copy() {
+	
+	return new DoubleVecExternalResult(this->id,this->enum_type,this->values,this->M,this->step,this->time);
+
+}
+/*}}}*/
+
+/*DoubleVecExternalResult management: */
+/*FUNCTION DoubleVecExternalResult::WriteData{{{*/
+void   DoubleVecExternalResult::WriteData(FILE* fid,bool io_gather){
+
+	int     length;
+	int     type;
+	int     size;
+	char   *name    = NULL;
+	extern  int my_rank;
+	IssmPDouble *passiveDouble_p=NULL;
+	IssmPDouble passiveDouble;
+
+	/*return if now on cpu 0: */
+	if(my_rank)return;
+
+	passiveDouble_p=xNew<IssmPDouble>(M);
+	/*First write enum: */
+	EnumToStringx(&name,this->enum_type);
+	length=(strlen(name)+1)*sizeof(char);
+	fwrite(&length,sizeof(int),1,fid);
+	fwrite(name,length,1,fid);
+	xDelete<char>(name);
+
+	/*Now write time and step: */
+        passiveDouble=reCast<IssmPDouble>(time);
+	fwrite(&passiveDouble,sizeof(IssmPDouble),1,fid);
+	fwrite(&step,sizeof(int),1,fid);
+
+	/*writing a IssmDouble, type is 1, size is 1: */
+	type=1;
+	size=this->M;
+	fwrite(&type,sizeof(int),1,fid);
+	fwrite(&size,sizeof(int),1,fid);
+        for (int i=0; i<M; ++i) passiveDouble_p[i]=reCast<IssmPDouble>(values[i]);
+	fwrite(passiveDouble_p,size*sizeof(IssmPDouble),1,fid);
+        xDelete(passiveDouble_p);
+}
+/*}}}*/
+/*FUNCTION DoubleVecExternalResult::GetResultName{{{*/
+void DoubleVecExternalResult::GetResultName(char** pname){
+	EnumToStringx(pname,this->enum_type);
+}
+/*}}}*/
+/*FUNCTION DoubleVecExternalResult::GetStep{{{*/
+int DoubleVecExternalResult::GetStep(void){
+
+	return this->step;
+}
+/*}}}*/
Index: issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/DoubleVecExternalResult.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/DoubleVecExternalResult.h	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/DoubleVecExternalResult.h	(revision 12878)
@@ -0,0 +1,55 @@
+/*! \file DoubleVecExternalResult.h 
+ */
+
+
+#ifndef _DOUBLEVECEXTERNALRESULT_H_
+#define _DOUBLEVECEXTERNALRESULT_H_
+
+/*Headers:*/
+/*{{{*/
+
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include "./ExternalResult.h"
+#include "../../../include/include.h"
+#include "../../../shared/shared.h"
+#include "../../../include/include.h"
+#include "../../../include/include.h"
+/*}}}*/
+
+class DoubleVecExternalResult: public ExternalResult{
+
+	private: 
+		int id;
+		int enum_type;
+		IssmDouble* values;
+		int M;
+		int step;
+		IssmDouble time;
+
+	public:
+		/*DoubleVecExternalResult constructors, destructors: {{{*/
+		DoubleVecExternalResult();
+		DoubleVecExternalResult(int id,int enum_type,IssmDouble* values,int M,int step, IssmDouble time);
+		~DoubleVecExternalResult();
+		/*}}}*/
+		/*Object virtual functions definitions:{{{ */
+		void  Echo();
+		void  DeepEcho();
+		int   Id(); 
+		int   MyRank();
+		int   ObjectEnum();
+		Object* copy();
+		/*}}}*/
+		/*ExternalResult management: {{{*/
+		int   InstanceEnum(){return enum_type;}
+		void  WriteData(FILE* fid,bool io_gather);
+		void  GetResultName(char**);
+		int   GetStep(void);
+		/*}}}*/
+};
+#endif  /* _DOUBLEVECEXTERNALRESULT_H */
Index: issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/ExternalResult.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/ExternalResult.h	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/ExternalResult.h	(revision 12878)
@@ -0,0 +1,34 @@
+/*!\file:  ExternalResult.h
+ * \brief abstract class for ExternalResult object
+ */ 
+
+
+#ifndef _EXTERNALRESULT_H_
+#define _EXTERNALRESULT_H_
+
+/*Headers:*/
+/*{{{*/
+
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include "../Object.h"
+#include "../Node.h"
+/*}}}*/
+
+class ExternalResult: public Object{
+
+	public: 
+		
+		virtual        ~ExternalResult(){};
+		/*Virtual functions:{{{*/
+		virtual int   InstanceEnum()=0;
+		virtual void  WriteData(FILE* fid,bool io_gather)=0;
+		virtual void  GetResultName(char**)=0;
+		virtual int   GetStep(void)=0;
+		/*}}}*/
+};
+#endif
Index: issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/IntExternalResult.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/IntExternalResult.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/IntExternalResult.cpp	(revision 12878)
@@ -0,0 +1,132 @@
+/*!\file IntExternalResult.c
+ * \brief: implementation of the IntExternalResult object
+ */
+
+/*header files: */
+/*{{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include <stdio.h>
+#include <string.h>
+#include "../objects.h"
+#include "../../../EnumDefinitions/EnumDefinitions.h"
+#include "../../../shared/shared.h"
+#include "../../../Container/Container.h"
+#include "../../../include/include.h"
+/*}}}*/
+
+/*IntExternalResult constructors and destructor*/
+/*FUNCTION IntExternalResult::IntExternalResult(){{{*/
+IntExternalResult::IntExternalResult(){
+	return;
+}
+/*}}}*/
+/*FUNCTION IntExternalResult::IntExternalResult(int in_id, int in_enum_type,int in_value,int in_step, IssmDouble in_time){{{*/
+IntExternalResult::IntExternalResult(int in_id, int in_enum_type,int in_value,int in_step, IssmDouble in_time){
+
+	id=in_id;
+	enum_type=in_enum_type;
+	value=in_value;
+	step=in_step;
+	time=in_time;
+}
+/*}}}*/
+/*FUNCTION IntExternalResult::~IntExternalResult(){{{*/
+IntExternalResult::~IntExternalResult(){
+	return;
+}
+/*}}}*/
+
+/*Object virtual functions definitions:*/
+/*FUNCTION IntExternalResult::Echo {{{*/
+void IntExternalResult::Echo(void){
+	this->DeepEcho();
+}
+/*}}}*/
+/*FUNCTION IntExternalResult::DeepEcho{{{*/
+void IntExternalResult::DeepEcho(void){
+
+	_printLine_("IntExternalResult:");
+	_printLine_("   id: " << this->id);
+	_printLine_("   enum:  " << this->enum_type << " (" << EnumToStringx(this->enum_type) << ")");
+	_printLine_("   value: " << this->value);
+	_printLine_("   step: " << this->step);
+	_printLine_("   time: " << this->time);
+}
+/*}}}*/
+/*FUNCTION IntExternalResult::Id{{{*/
+int    IntExternalResult::Id(void){ return -1; }
+/*}}}*/
+/*FUNCTION IntExternalResult::MyRank{{{*/
+int    IntExternalResult::MyRank(void){ 
+	extern int my_rank;
+	return my_rank; 
+}
+/*}}}*/
+/*FUNCTION IntExternalResult::ObjectEnum{{{*/
+int IntExternalResult::ObjectEnum(void){
+
+	return IntExternalResultEnum;
+
+}
+/*}}}*/
+/*FUNCTION IntExternalResult::copy{{{*/
+Object* IntExternalResult::copy() {
+	
+	return new IntExternalResult(this->id,this->enum_type,this->value,this->step,this->time);
+
+}
+/*}}}*/
+
+/*IntExternalResult management: */
+/*FUNCTION IntExternalResult::WriteData{{{*/
+void   IntExternalResult::WriteData(FILE* fid,bool io_gather){
+
+	int     length;
+	int     type;
+	int     size;
+	char   *name    = NULL;
+	IssmPDouble  passiveDouble;
+	extern  int my_rank;
+
+	/*return if now on cpu 0: */
+	if(my_rank)return;
+
+	/*First write enum: */
+	EnumToStringx(&name,this->enum_type);
+	length=(strlen(name)+1)*sizeof(char);
+	fwrite(&length,sizeof(int),1,fid);
+	fwrite(name,length,1,fid);
+	xDelete<char>(name);
+
+	/*Now write time and step: */
+        passiveDouble=reCast<IssmPDouble>(time);
+	fwrite(&passiveDouble,sizeof(IssmPDouble),1,fid);
+	fwrite(&step,sizeof(int),1,fid);
+
+	/*writing a IssmPDouble, type is 1, size is 1: */
+	type=1;
+	size=1;
+	fwrite(&type,sizeof(int),1,fid);
+	fwrite(&size,sizeof(int),1,fid);
+        /*cast to a IssmPDouble: */
+        passiveDouble=reCast<IssmPDouble>(value);
+	fwrite(&passiveDouble,size*sizeof(IssmPDouble),1,fid);
+
+}
+/*}}}*/
+/*FUNCTION IntExternalResult::GetResultName{{{*/
+void IntExternalResult::GetResultName(char** pname){
+	EnumToStringx(pname,this->enum_type);
+}
+/*}}}*/
+/*FUNCTION IntExternalResult::GetStep{{{*/
+int IntExternalResult::GetStep(void){
+
+	return this->step;
+}
+/*}}}*/
Index: issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/IntExternalResult.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/IntExternalResult.h	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/IntExternalResult.h	(revision 12878)
@@ -0,0 +1,54 @@
+/*! \file IntExternalResult.h 
+ *  \brief: header file for triavertexinput object
+ */
+
+
+#ifndef _INTEXTERNALRESULT_H_
+#define _INTEXTERNALRESULT_H_
+
+/*Headers:*/
+/*{{{*/
+
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include "./ExternalResult.h"
+#include "../../../include/include.h"
+#include "../../../shared/shared.h"
+/*}}}*/
+
+class IntExternalResult: public ExternalResult{
+
+	public:
+		int    id;
+		int    enum_type;
+		int    value;
+		int    step;
+		IssmDouble time;
+
+
+		/*IntExternalResult constructors, destructors: {{{*/
+		IntExternalResult();
+		IntExternalResult(int id,int enum_type,int value,int step,IssmDouble time);
+		~IntExternalResult();
+
+		/*}}}*/
+		/*Object virtual functions definitions:{{{ */
+		void  Echo();
+		void  DeepEcho();
+		int   Id(); 
+		int   MyRank();
+		int   ObjectEnum();
+		Object* copy();
+		/*}}}*/
+		/*ExternalResult managemnet: {{{*/
+		int   InstanceEnum(){return enum_type;}
+		void  WriteData(FILE* fid,bool io_gather);
+		void  GetResultName(char**);
+		int   GetStep(void);
+		/*}}}*/
+};
+#endif  /* _INTEXTERNALRESULT_H */
Index: issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/PetscVecExternalResult.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/PetscVecExternalResult.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/PetscVecExternalResult.cpp	(revision 12878)
@@ -0,0 +1,149 @@
+/*!\file PetscVecExternalResult.c
+ * \brief: implementation of the PetscVecExternalResult object
+ */
+
+/*header files: */
+/*{{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include <stdio.h>
+#include <string.h>
+#include "../objects.h"
+#include "../../../EnumDefinitions/EnumDefinitions.h"
+#include "../../../shared/shared.h"
+#include "../../../Container/Container.h"
+#include "../../../include/include.h"
+/*}}}*/
+
+/*PetscVecExternalResult constructors and destructor*/
+/*FUNCTION PetscVecExternalResult::PetscVecExternalResult(){{{*/
+PetscVecExternalResult::PetscVecExternalResult(){
+	return;
+}
+/*}}}*/
+/*FUNCTION PetscVecExternalResult::PetscVecExternalResult(int enum_type,IssmPetscVec value){{{*/
+PetscVecExternalResult::PetscVecExternalResult(int in_id, int in_enum_type,Vector* in_value,int in_step, IssmDouble in_time){
+
+	id=in_id;
+	enum_type=in_enum_type;
+
+	value=NULL;
+
+	if(in_value){
+		value=in_value->Duplicate();
+		in_value->Copy(value);
+	}
+	else value=NULL;
+
+	step=in_step;
+	time=in_time;
+}
+/*}}}*/
+/*FUNCTION PetscVecExternalResult::~PetscVecExternalResult(){{{*/
+PetscVecExternalResult::~PetscVecExternalResult(){
+	VecFree(&value);
+}
+/*}}}*/
+
+/*Object virtual functions definitions:*/
+/*FUNCTION PetscVecExternalResult::Echo {{{*/
+void PetscVecExternalResult::Echo(void){
+
+	_printLine_("PetscVecExternalResult:");
+	_printLine_("   enum: " << this->enum_type << " (" << EnumToStringx(this->enum_type) << ")");
+
+}
+/*}}}*/
+/*FUNCTION PetscVecExternalResult::DeepEcho{{{*/
+void PetscVecExternalResult::DeepEcho(void){
+
+	int i;
+	_printLine_("PetscVecExternalResult:");
+	_printLine_("   id: " << this->id);
+	_printLine_("   enum: " << this->enum_type << " (" << EnumToStringx(this->enum_type) << ")");
+	_printLine_("   step: " << this->step);
+	_printLine_("   time: " << this->time);
+	VecView(value,PETSC_VIEWER_STDOUT_WORLD);
+}
+/*}}}*/
+/*FUNCTION PetscVecExternalResult::Id{{{*/
+int    PetscVecExternalResult::Id(void){ return -1; }
+/*}}}*/
+/*FUNCTION PetscVecExternalResult::MyRank{{{*/
+int    PetscVecExternalResult::MyRank(void){ 
+	extern int my_rank;
+	return my_rank; 
+}
+/*}}}*/
+/*FUNCTION PetscVecExternalResult::ObjectEnum{{{*/
+int PetscVecExternalResult::ObjectEnum(void){
+
+	return PetscVecExternalResultEnum;
+
+}
+/*}}}*/
+/*FUNCTION PetscVecExternalResult::copy{{{*/
+Object* PetscVecExternalResult::copy() {
+	
+	return new PetscVecExternalResult(this->id,this->enum_type,this->value,this->step,this->time);
+
+}
+/*}}}*/
+
+/*PetscVecExternalResult management: */
+/*FUNCTION PetscVecExternalResult::WriteData{{{*/
+void   PetscVecExternalResult::WriteData(FILE* fid,bool io_gather){
+
+	int     length;
+	int     type;
+	int     size;
+	char   *name      = NULL;
+	IssmPDouble *serialvec = NULL;
+	extern int my_rank;
+	IssmPDouble passiveDouble;
+
+	/*serialize: */
+	VecGetSize(this->value,&size);
+	VecToMPISerial(&serialvec,this->value);
+
+	/*now, exit if we are not on cpu 0: */
+	if(my_rank)return;
+
+	/*First write enum: */
+	EnumToStringx(&name,this->enum_type);
+	length=(strlen(name)+1)*sizeof(char);
+	fwrite(&length,sizeof(int),1,fid);
+	fwrite(name,length,1,fid);
+	xDelete<char>(name);
+
+	/*Now write time and step: */
+        passiveDouble=reCast<IssmPDouble>(time);
+	fwrite(&passiveDouble,sizeof(IssmPDouble),1,fid);
+	fwrite(&step,sizeof(int),1,fid);
+
+	/*writing a IssmDouble, type is 1, size is 1: */
+	type=1;
+	
+	fwrite(&type,sizeof(int),1,fid);
+	fwrite(&size,sizeof(int),1,fid);
+	fwrite(serialvec,size*sizeof(IssmPDouble),1,fid);
+
+	/*Free ressources:*/
+	xDelete<IssmPDouble>(serialvec);
+}
+/*}}}*/
+/*FUNCTION PetscVecExternalResult::GetResultName{{{*/
+void PetscVecExternalResult::GetResultName(char**pname){
+	EnumToStringx(pname,this->enum_type);
+}
+/*}}}*/
+/*FUNCTION PetscVecExternalResult::GetStep{{{*/
+int PetscVecExternalResult::GetStep(void){
+
+	return this->step;
+}
+/*}}}*/
Index: issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/PetscVecExternalResult.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/PetscVecExternalResult.h	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/PetscVecExternalResult.h	(revision 12878)
@@ -0,0 +1,55 @@
+/*! \file PetscVecExternalResult.h 
+ *  \brief: header file for triavertexinput object
+ */
+
+
+#ifndef _PETSCVECEXTERNALRESULT_H_
+#define _PETSCVECEXTERNALRESULT_H_
+
+/*Headers:*/
+/*{{{*/
+
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include "./ExternalResult.h"
+#include "../../../include/include.h"
+#include "../../../shared/shared.h"
+#include "../../../include/include.h"
+#include "../../../include/include.h"
+/*}}}*/
+
+class PetscVecExternalResult: public ExternalResult{
+
+	private: 
+		int id;
+		int enum_type;
+		Vector* value;
+		int step;
+		IssmDouble time;
+
+	public:
+		/*PetscVecExternalResult constructors, destructors: {{{*/
+		PetscVecExternalResult();
+		PetscVecExternalResult(int id,int enum_type,Vector* value, int step, IssmDouble time);
+		~PetscVecExternalResult();
+		/*}}}*/
+		/*Object virtual functions definitions:{{{ */
+		void  Echo();
+		void  DeepEcho();
+		int   Id(); 
+		int   MyRank();
+		int   ObjectEnum();
+		Object* copy();
+		/*}}}*/
+		/*ExternalResult management: {{{*/
+		int   InstanceEnum(){return enum_type;}
+		void  WriteData(FILE* fid,bool io_gather);
+		void  GetResultName(char**);
+		int   GetStep(void);
+		/*}}}*/
+};
+#endif  /* _PETSCVECEXTERNALRESULT_H */
Index: issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/StringExternalResult.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/StringExternalResult.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/StringExternalResult.cpp	(revision 12878)
@@ -0,0 +1,132 @@
+/*!\file StringExternalResult.c
+ * \brief: implementation of the StringExternalResult object
+ */
+
+/*header files: */
+/*{{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include <stdio.h>
+#include <string.h>
+#include "../objects.h"
+#include "../../../EnumDefinitions/EnumDefinitions.h"
+#include "../../../shared/shared.h"
+#include "../../../Container/Container.h"
+#include "../../../include/include.h"
+/*}}}*/
+
+/*StringExternalResult constructors and destructor*/
+/*FUNCTION StringExternalResult::StringExternalResult(){{{*/
+StringExternalResult::StringExternalResult(){
+	return;
+}
+/*}}}*/
+/*FUNCTION StringExternalResult::StringExternalResult(int enum_type,IssmString value){{{*/
+StringExternalResult::StringExternalResult(int in_id, int in_enum_type,char* in_value,int in_step, IssmDouble in_time){
+
+	id=in_id;
+	enum_type=in_enum_type;
+	value=xNew<char>(strlen(in_value)+1);
+	xMemCpy<char>(value,in_value,(strlen(in_value)+1));
+	step=in_step;
+	time=in_time;
+	
+}
+/*}}}*/
+/*FUNCTION StringExternalResult::~StringExternalResult(){{{*/
+StringExternalResult::~StringExternalResult(){
+	xDelete<char>(value);
+}
+/*}}}*/
+
+/*Object virtual functions definitions:*/
+/*FUNCTION StringExternalResult::Echo {{{*/
+void StringExternalResult::Echo(void){
+	this->DeepEcho();
+}
+/*}}}*/
+/*FUNCTION StringExternalResult::DeepEcho{{{*/
+void StringExternalResult::DeepEcho(void){
+
+	_printLine_("StringExternalResult:");
+	_printLine_("   id: " << this->id);
+	_printLine_("   enum:  " << this->enum_type << " (" << EnumToStringx(this->enum_type) << ")");
+	_printLine_("   value: " << this->value);
+	_printLine_("   step: " << this->step);
+	_printLine_("   time: " << this->time);
+}
+/*}}}*/
+/*FUNCTION StringExternalResult::Id{{{*/
+int    StringExternalResult::Id(void){ return -1; }
+/*}}}*/
+/*FUNCTION StringExternalResult::MyRank{{{*/
+int    StringExternalResult::MyRank(void){ 
+	extern int my_rank;
+	return my_rank; 
+}
+/*}}}*/
+/*FUNCTION StringExternalResult::ObjectEnum{{{*/
+int StringExternalResult::ObjectEnum(void){
+
+	return StringExternalResultEnum;
+
+}
+/*}}}*/
+/*FUNCTION StringExternalResult::copy{{{*/
+Object* StringExternalResult::copy() {
+	
+	return new StringExternalResult(this->id,this->enum_type,this->value,this->step,this->time);
+
+}
+/*}}}*/
+
+/*StringExternalResult management: */
+/*FUNCTION StringExternalResult::WriteData{{{*/
+void   StringExternalResult::WriteData(FILE* fid,bool io_gather){
+
+	int     length;
+	int     type;
+	char   *name      = NULL;
+	extern  int my_rank;
+        IssmPDouble passiveDouble;
+
+	/*return if now on cpu 0: */
+	if(my_rank)return;
+
+	/*First write enum: */
+	EnumToStringx(&name,this->enum_type);
+	length=(strlen(name)+1)*sizeof(char);
+	fwrite(&length,sizeof(int),1,fid);
+	fwrite(name,length,1,fid);
+	xDelete<char>(name);
+
+	/*Now write time and step: */
+        passiveDouble=reCast<IssmPDouble>(time);
+	fwrite(&passiveDouble,sizeof(IssmPDouble),1,fid);
+	fwrite(&step,sizeof(int),1,fid);
+
+	/*writing a string, type is 2: */
+	type=2;
+	fwrite(&type,sizeof(int),1,fid);
+	
+	length=(strlen(this->value)+1)*sizeof(char);
+	fwrite(&length,sizeof(int),1,fid);
+	fwrite(this->value,length,1,fid);
+
+}
+/*}}}*/
+/*FUNCTION StringExternalResult::GetResultName{{{*/
+void StringExternalResult::GetResultName(char**pname){
+	EnumToStringx(pname,this->enum_type);
+}
+/*}}}*/
+/*FUNCTION StringExternalResult::GetStep{{{*/
+int StringExternalResult::GetStep(void){
+
+	return this->step;
+}
+/*}}}*/
Index: issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/StringExternalResult.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/StringExternalResult.h	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/objects/ExternalResults/StringExternalResult.h	(revision 12878)
@@ -0,0 +1,55 @@
+/*! \file StringExternalResult.h 
+ *  \brief: header file for triavertexinput object
+ */
+
+
+#ifndef _STRINGEXTERNALRESULT_H_
+#define _STRINGEXTERNALRESULT_H_
+
+/*Headers:*/
+/*{{{*/
+
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include "./ExternalResult.h"
+#include "../../../include/include.h"
+#include "../../../shared/shared.h"
+#include "../../../include/include.h"
+#include "../../../include/include.h"
+/*}}}*/
+
+class StringExternalResult: public ExternalResult{
+
+	private: 
+		int    id;
+		int    enum_type;
+		char*  value;
+		int    step;
+		IssmDouble time;
+
+	public:
+		/*StringExternalResult constructors, destructors: {{{*/
+		StringExternalResult();
+		StringExternalResult(int id,int enum_type,char* value,int step, IssmDouble time);
+		~StringExternalResult();
+		/*}}}*/
+		/*Object virtual functions definitions:{{{ */
+		void  Echo();
+		void  DeepEcho();
+		int   Id(); 
+		int   MyRank();
+		int   ObjectEnum();
+		Object* copy();
+		/*}}}*/
+		/*ExternalResult management: {{{*/
+		int   InstanceEnum(){return enum_type;}
+		void  WriteData(FILE* fid,bool io_gather);
+		void  GetResultName(char**);
+		int   GetStep(void);
+		/*}}}*/
+};
+#endif  /* _STRINGEXTERNALRESULT_H */
